"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from typing import Optional
from typing_extensions import NotRequired, TypedDict
from zendesk.types import BaseModel


class CustomRoleConfigurationObjectTypedDict(TypedDict):
    r"""Configuration settings for the role. See [Configuration](#configuration)"""

    assign_tickets_to_any_group: NotRequired[bool]
    r"""Whether or not the agent can assign tickets to any group"""
    chat_access: NotRequired[bool]
    r"""Whether or not the agent has access to Chat"""
    end_user_list_access: NotRequired[str]
    r"""Whether or not the agent can view lists of user profiles. Allowed values: \"full\", \"none\" """
    end_user_profile_access: NotRequired[str]
    r"""What the agent can do with end-user profiles. Allowed values: \"edit\", \"edit-within-org\", \"full\", \"readonly\" """
    explore_access: NotRequired[str]
    r"""Allowed values: \"edit\", \"full\", \"none\", \"readonly\" """
    forum_access: NotRequired[str]
    r"""The kind of access the agent has to Guide. Allowed values: \"edit-topics\", \"full\", \"readonly\" """
    forum_access_restricted_content: NotRequired[bool]
    group_access: NotRequired[bool]
    r"""Whether or not the agent can add or modify groups"""
    light_agent: NotRequired[bool]
    macro_access: NotRequired[str]
    r"""What the agent can do with macros. Allowed values: \"full\", \"manage-group\", \"manage-personal\", \"readonly\" """
    manage_business_rules: NotRequired[bool]
    r"""Whether or not the agent can manage business rules"""
    manage_contextual_workspaces: NotRequired[bool]
    r"""Whether or not the agent can view, add, and edit contextual workspaces"""
    manage_dynamic_content: NotRequired[bool]
    r"""Whether or not the agent can access dynamic content"""
    manage_extensions_and_channels: NotRequired[bool]
    r"""Whether or not the agent can manage channels and extensions"""
    manage_facebook: NotRequired[bool]
    r"""Whether or not the agent can manage Facebook pages"""
    manage_organization_fields: NotRequired[bool]
    r"""Whether or not the agent can create and manage organization fields"""
    manage_ticket_fields: NotRequired[bool]
    r"""Whether or not the agent can create and manage ticket fields"""
    manage_ticket_forms: NotRequired[bool]
    r"""Whether or not the agent can create and manage ticket forms"""
    manage_user_fields: NotRequired[bool]
    r"""Whether or not the agent can create and manage user fields"""
    moderate_forums: NotRequired[bool]
    organization_editing: NotRequired[bool]
    r"""Whether or not the agent can add or modify organizations"""
    organization_notes_editing: NotRequired[bool]
    r"""Whether or not the agent can add or modify organization notes"""
    report_access: NotRequired[str]
    r"""What the agent can do with reports. Allowed values: \"full\", \"none\", \"readonly\" """
    side_conversation_create: NotRequired[bool]
    r"""Whether or not the agent can contribute to side conversations"""
    ticket_access: NotRequired[str]
    r"""What kind of tickets the agent can access. Allowed values: \"all\", \"assigned-only\", \"within-groups\", \"within-groups-and-public-groups\", \"within-organization\" """
    ticket_comment_access: NotRequired[str]
    r"""What type of comments the agent can make. Allowed values: \"public\", \"none\" """
    ticket_deletion: NotRequired[bool]
    r"""Whether or not the agent can delete tickets"""
    ticket_editing: NotRequired[bool]
    r"""Whether or not the agent can edit ticket properties"""
    ticket_merge: NotRequired[bool]
    r"""Whether or not the agent can merge tickets"""
    ticket_tag_editing: NotRequired[bool]
    r"""Whether or not the agent can edit ticket tags"""
    twitter_search_access: NotRequired[bool]
    user_view_access: NotRequired[str]
    r"""What the agent can do with customer lists. Allowed values: \"full\", \"manage-group\", \"manage-personal\", \"none\", \"readonly\" """
    view_access: NotRequired[str]
    r"""What the agent can do with views. Allowed values: \"full\", \"manage-group\", \"manage-personal\", \"playonly\", \"readonly\" """
    view_deleted_tickets: NotRequired[bool]
    r"""Whether or not the agent can view deleted tickets"""
    voice_access: NotRequired[bool]
    r"""Whether or not the agent can answer and place calls to end users"""
    voice_dashboard_access: NotRequired[bool]
    r"""Whether or not the agent can view details about calls on the Talk dashboard"""


class CustomRoleConfigurationObject(BaseModel):
    r"""Configuration settings for the role. See [Configuration](#configuration)"""

    assign_tickets_to_any_group: Optional[bool] = None
    r"""Whether or not the agent can assign tickets to any group"""

    chat_access: Optional[bool] = None
    r"""Whether or not the agent has access to Chat"""

    end_user_list_access: Optional[str] = None
    r"""Whether or not the agent can view lists of user profiles. Allowed values: \"full\", \"none\" """

    end_user_profile_access: Optional[str] = None
    r"""What the agent can do with end-user profiles. Allowed values: \"edit\", \"edit-within-org\", \"full\", \"readonly\" """

    explore_access: Optional[str] = None
    r"""Allowed values: \"edit\", \"full\", \"none\", \"readonly\" """

    forum_access: Optional[str] = None
    r"""The kind of access the agent has to Guide. Allowed values: \"edit-topics\", \"full\", \"readonly\" """

    forum_access_restricted_content: Optional[bool] = None

    group_access: Optional[bool] = None
    r"""Whether or not the agent can add or modify groups"""

    light_agent: Optional[bool] = None

    macro_access: Optional[str] = None
    r"""What the agent can do with macros. Allowed values: \"full\", \"manage-group\", \"manage-personal\", \"readonly\" """

    manage_business_rules: Optional[bool] = None
    r"""Whether or not the agent can manage business rules"""

    manage_contextual_workspaces: Optional[bool] = None
    r"""Whether or not the agent can view, add, and edit contextual workspaces"""

    manage_dynamic_content: Optional[bool] = None
    r"""Whether or not the agent can access dynamic content"""

    manage_extensions_and_channels: Optional[bool] = None
    r"""Whether or not the agent can manage channels and extensions"""

    manage_facebook: Optional[bool] = None
    r"""Whether or not the agent can manage Facebook pages"""

    manage_organization_fields: Optional[bool] = None
    r"""Whether or not the agent can create and manage organization fields"""

    manage_ticket_fields: Optional[bool] = None
    r"""Whether or not the agent can create and manage ticket fields"""

    manage_ticket_forms: Optional[bool] = None
    r"""Whether or not the agent can create and manage ticket forms"""

    manage_user_fields: Optional[bool] = None
    r"""Whether or not the agent can create and manage user fields"""

    moderate_forums: Optional[bool] = None

    organization_editing: Optional[bool] = None
    r"""Whether or not the agent can add or modify organizations"""

    organization_notes_editing: Optional[bool] = None
    r"""Whether or not the agent can add or modify organization notes"""

    report_access: Optional[str] = None
    r"""What the agent can do with reports. Allowed values: \"full\", \"none\", \"readonly\" """

    side_conversation_create: Optional[bool] = None
    r"""Whether or not the agent can contribute to side conversations"""

    ticket_access: Optional[str] = None
    r"""What kind of tickets the agent can access. Allowed values: \"all\", \"assigned-only\", \"within-groups\", \"within-groups-and-public-groups\", \"within-organization\" """

    ticket_comment_access: Optional[str] = None
    r"""What type of comments the agent can make. Allowed values: \"public\", \"none\" """

    ticket_deletion: Optional[bool] = None
    r"""Whether or not the agent can delete tickets"""

    ticket_editing: Optional[bool] = None
    r"""Whether or not the agent can edit ticket properties"""

    ticket_merge: Optional[bool] = None
    r"""Whether or not the agent can merge tickets"""

    ticket_tag_editing: Optional[bool] = None
    r"""Whether or not the agent can edit ticket tags"""

    twitter_search_access: Optional[bool] = None

    user_view_access: Optional[str] = None
    r"""What the agent can do with customer lists. Allowed values: \"full\", \"manage-group\", \"manage-personal\", \"none\", \"readonly\" """

    view_access: Optional[str] = None
    r"""What the agent can do with views. Allowed values: \"full\", \"manage-group\", \"manage-personal\", \"playonly\", \"readonly\" """

    view_deleted_tickets: Optional[bool] = None
    r"""Whether or not the agent can view deleted tickets"""

    voice_access: Optional[bool] = None
    r"""Whether or not the agent can answer and place calls to end users"""

    voice_dashboard_access: Optional[bool] = None
    r"""Whether or not the agent can view details about calls on the Talk dashboard"""
